/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-21 at 22:46:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.freebase;

/**
 * Service definition for Freebase (v1sandbox).
 *
 * <p>
 * Topic and MQL APIs provide you structured access to Freebase data.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/freebase/" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link FreebaseRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Freebase extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    com.google.api.client.util.Preconditions.checkState(
        com.google.api.client.googleapis.GoogleUtils.MAJOR_VERSION == 1 &&
        com.google.api.client.googleapis.GoogleUtils.MINOR_VERSION >= 15,
        "You are currently running with version %s of google-api-client. " +
        "You need at least version 1.15 of google-api-client to run version " +
        "1.15.0-rc of the Freebase API library.", com.google.api.client.googleapis.GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "freebase/v1sandbox/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   */
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport, which should normally be:
   *        <ul>
   *        <li>Google App Engine:
   *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
   *        <li>Android: {@code newCompatibleTransport} from
   *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
   *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
   *        </li>
   *        </ul>
   * @param jsonFactory JSON factory, which may be:
   *        <ul>
   *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
   *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
   *        <li>Android Honeycomb or higher:
   *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
   *        </ul>
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Freebase(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
      com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
    this(new Builder(transport, jsonFactory, httpRequestInitializer));
  }

  /**
   * @param builder builder
   */
  Freebase(Builder builder) {
    super(builder);
  }

  @Override
  protected void initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Text collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Freebase freebase = new Freebase(...);}
   *   {@code Freebase.Text.List request = freebase.text().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Text text() {
    return new Text();
  }

  /**
   * The "text" collection of methods.
   */
  public class Text {

    /**
     * Returns blob attached to node at specified id as HTML
     *
     * Create a request for the method "text.get".
     *
     * This request holds the parameters needed by the the freebase server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param id The id of the item that you want data about
     * @return the request
     */
    public Get get(java.util.List<java.lang.String> id) throws java.io.IOException {
      Get result = new Get(id);
      initialize(result);
      return result;
    }

    public class Get extends FreebaseRequest<com.google.api.services.freebase.model.ContentserviceGet> {

      private static final String REST_PATH = "text{/id*}";

      /**
       * Returns blob attached to node at specified id as HTML
       *
       * Create a request for the method "text.get".
       *
       * This request holds the parameters needed by the the freebase server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
       * must be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param id The id of the item that you want data about
       * @since 1.13
       */
      protected Get(java.util.List<java.lang.String> id) {
        super(Freebase.this, "GET", REST_PATH, null, com.google.api.services.freebase.model.ContentserviceGet.class);
        this.id = com.google.api.client.util.Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(java.lang.String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(java.lang.String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(java.lang.String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(java.lang.String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(java.lang.String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(java.lang.String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The id of the item that you want data about */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> id;

      /** The id of the item that you want data about
       */
      public java.util.List<java.lang.String> getId() {
        return id;
      }

      /** The id of the item that you want data about */
      public Get setId(java.util.List<java.lang.String> id) {
        this.id = id;
        return this;
      }

      /** The max number of characters to return. Valid only for 'plain' format. */
      @com.google.api.client.util.Key
      private java.lang.Long maxlength;

      /** The max number of characters to return. Valid only for 'plain' format.
       */
      public java.lang.Long getMaxlength() {
        return maxlength;
      }

      /** The max number of characters to return. Valid only for 'plain' format. */
      public Get setMaxlength(java.lang.Long maxlength) {
        this.maxlength = maxlength;
        return this;
      }

      /** Sanitizing transformation. */
      @com.google.api.client.util.Key
      private java.lang.String format;

      /** Sanitizing transformation. [default: plain]
       */
      public java.lang.String getFormat() {
        return format;
      }

      /** Sanitizing transformation. */
      public Get setFormat(java.lang.String format) {
        this.format = format;
        return this;
      }

      @Override
      public Get set(String parameterName, Object value) {
        return (Get) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Topic collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Freebase freebase = new Freebase(...);}
   *   {@code Freebase.Topic.List request = freebase.topic().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Topic topic() {
    return new Topic();
  }

  /**
   * The "topic" collection of methods.
   */
  public class Topic {

    /**
     * Get properties and meta-data about a topic.
     *
     * Create a request for the method "topic.lookup".
     *
     * This request holds the parameters needed by the the freebase server.  After setting any optional
     * parameters, call the {@link Lookup#execute()} method to invoke the remote operation.
     *
     * @param id The id of the item that you want data about.
     * @return the request
     */
    public Lookup lookup(java.util.List<java.lang.String> id) throws java.io.IOException {
      Lookup result = new Lookup(id);
      initialize(result);
      return result;
    }

    public class Lookup extends FreebaseRequest<com.google.api.services.freebase.model.TopicLookup> {

      private static final String REST_PATH = "topic{/id*}";

      /**
       * Get properties and meta-data about a topic.
       *
       * Create a request for the method "topic.lookup".
       *
       * This request holds the parameters needed by the the freebase server.  After setting any
       * optional parameters, call the {@link Lookup#execute()} method to invoke the remote operation.
       * <p> {@link
       * Lookup#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param id The id of the item that you want data about.
       * @since 1.13
       */
      protected Lookup(java.util.List<java.lang.String> id) {
        super(Freebase.this, "GET", REST_PATH, null, com.google.api.services.freebase.model.TopicLookup.class);
        this.id = com.google.api.client.util.Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Lookup setAlt(java.lang.String alt) {
        return (Lookup) super.setAlt(alt);
      }

      @Override
      public Lookup setFields(java.lang.String fields) {
        return (Lookup) super.setFields(fields);
      }

      @Override
      public Lookup setKey(java.lang.String key) {
        return (Lookup) super.setKey(key);
      }

      @Override
      public Lookup setOauthToken(java.lang.String oauthToken) {
        return (Lookup) super.setOauthToken(oauthToken);
      }

      @Override
      public Lookup setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Lookup) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Lookup setQuotaUser(java.lang.String quotaUser) {
        return (Lookup) super.setQuotaUser(quotaUser);
      }

      @Override
      public Lookup setUserIp(java.lang.String userIp) {
        return (Lookup) super.setUserIp(userIp);
      }

      /** The id of the item that you want data about. */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> id;

      /** The id of the item that you want data about.
       */
      public java.util.List<java.lang.String> getId() {
        return id;
      }

      /** The id of the item that you want data about. */
      public Lookup setId(java.util.List<java.lang.String> id) {
        this.id = id;
        return this;
      }

      /** The language you 'd like the content in - a freebase /type/lang language key. */
      @com.google.api.client.util.Key
      private java.lang.String lang;

      /** The language you 'd like the content in - a freebase /type/lang language key. [default: en]
       */
      public java.lang.String getLang() {
        return lang;
      }

      /** The language you 'd like the content in - a freebase /type/lang language key. */
      public Lookup setLang(java.lang.String lang) {
        this.lang = lang;
        return this;
      }

      /** Determines how up-to-date the data returned is. A unix epoch time, a guid or a 'now' */
      @com.google.api.client.util.Key
      private java.lang.String dateline;

      /** Determines how up-to-date the data returned is. A unix epoch time, a guid or a 'now'
       */
      public java.lang.String getDateline() {
        return dateline;
      }

      /** Determines how up-to-date the data returned is. A unix epoch time, a guid or a 'now' */
      public Lookup setDateline(java.lang.String dateline) {
        this.dateline = dateline;
        return this;
      }

      /**
       * A frebase domain, type or property id, 'suggest', 'commons', or 'all'. Filter the results
       * and returns only appropriate properties.
       */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> filter;

      /** A frebase domain, type or property id, 'suggest', 'commons', or 'all'. Filter the results and
     returns only appropriate properties.
       */
      public java.util.List<java.lang.String> getFilter() {
        return filter;
      }

      /**
       * A frebase domain, type or property id, 'suggest', 'commons', or 'all'. Filter the results
       * and returns only appropriate properties.
       */
      public Lookup setFilter(java.util.List<java.lang.String> filter) {
        this.filter = filter;
        return this;
      }

      /** Do not apply any constraints, or get any names. */
      @com.google.api.client.util.Key
      private java.lang.Boolean raw;

      /** Do not apply any constraints, or get any names. [default: false]
       */
      public java.lang.Boolean getRaw() {
        return raw;
      }

      /** Do not apply any constraints, or get any names. */
      public Lookup setRaw(java.lang.Boolean raw) {
        this.raw = raw;
        return this;
      }

      /**
       * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
       *
       * <p>
       * Boolean properties can have four possible values:
       * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
       * or {@link Boolean#FALSE}.
       * </p>
       *
       * <p>
       * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
       * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
       * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * </p>
       *
       * <p>
       * Do not apply any constraints, or get any names.
       * </p>
       */
      public boolean isRaw() {
        if (raw == null || raw == com.google.api.client.util.Data.NULL_BOOLEAN) {
          return false;
        }
        return raw;
      }

      /** The maximum number of property values to return for each property. */
      @com.google.api.client.util.Key
      private java.lang.Long limit;

      /** The maximum number of property values to return for each property. [default: 10]
       */
      public java.lang.Long getLimit() {
        return limit;
      }

      /** The maximum number of property values to return for each property. */
      public Lookup setLimit(java.lang.Long limit) {
        this.limit = limit;
        return this;
      }

      @Override
      public Lookup set(String parameterName, Object value) {
        return (Lookup) super.set(parameterName, value);
      }
    }

  }

  /**
   * Returns the scaled/cropped image attached to a freebase node.
   *
   * Create a request for the method "image".
   *
   * This request holds the parameters needed by the the freebase server.  After setting any optional
   * parameters, call the {@link Image#execute()} method to invoke the remote operation.
   *
   * @param id Freebase entity or content id, mid, or guid.
   * @return the request
   */
  public Image image(java.util.List<java.lang.String> id) throws java.io.IOException {
    Image result = new Image(id);
    initialize(result);
    return result;
  }

  public class Image extends FreebaseRequest<Void> {

    private static final String REST_PATH = "image{/id*}";

    private final java.util.regex.Pattern FALLBACKID_PATTERN =
        java.util.regex.Pattern.compile("/[^.]*$");

    /**
     * Returns the scaled/cropped image attached to a freebase node.
     *
     * Create a request for the method "image".
     *
     * This request holds the parameters needed by the the freebase server.  After setting any
     * optional parameters, call the {@link Image#execute()} method to invoke the remote operation.
     * <p> {@link
     * Image#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
     * be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param id Freebase entity or content id, mid, or guid.
     * @since 1.13
     */
    protected Image(java.util.List<java.lang.String> id) {
      super(Freebase.this, "GET", REST_PATH, null, Void.class);
      this.id = com.google.api.client.util.Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      initializeMediaDownload();
    }

    @Override
    public void executeMediaAndDownloadTo(java.io.OutputStream outputStream) throws java.io.IOException {
      super.executeMediaAndDownloadTo(outputStream);
    }

    @Override
    public java.io.InputStream executeMediaAsInputStream() throws java.io.IOException {
      return super.executeMediaAsInputStream();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeMedia() throws java.io.IOException {
      return super.executeMedia();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
      return super.executeUsingHead();
    }

    @Override
    public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
      return super.buildHttpRequestUsingHead();
    }

    @Override
    public Image setAlt(java.lang.String alt) {
      return (Image) super.setAlt(alt);
    }

    @Override
    public Image setFields(java.lang.String fields) {
      return (Image) super.setFields(fields);
    }

    @Override
    public Image setKey(java.lang.String key) {
      return (Image) super.setKey(key);
    }

    @Override
    public Image setOauthToken(java.lang.String oauthToken) {
      return (Image) super.setOauthToken(oauthToken);
    }

    @Override
    public Image setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (Image) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public Image setQuotaUser(java.lang.String quotaUser) {
      return (Image) super.setQuotaUser(quotaUser);
    }

    @Override
    public Image setUserIp(java.lang.String userIp) {
      return (Image) super.setUserIp(userIp);
    }

    /** Freebase entity or content id, mid, or guid. */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> id;

    /** Freebase entity or content id, mid, or guid.
     */
    public java.util.List<java.lang.String> getId() {
      return id;
    }

    /** Freebase entity or content id, mid, or guid. */
    public Image setId(java.util.List<java.lang.String> id) {
      this.id = id;
      return this;
    }

    /** Maximum width in pixels for resulting image. */
    @com.google.api.client.util.Key
    private java.lang.Long maxwidth;

    /** Maximum width in pixels for resulting image.

   [maximum: 4096]
     */
    public java.lang.Long getMaxwidth() {
      return maxwidth;
    }

    /** Maximum width in pixels for resulting image. */
    public Image setMaxwidth(java.lang.Long maxwidth) {
      this.maxwidth = maxwidth;
      return this;
    }

    /** Maximum height in pixels for resulting image. */
    @com.google.api.client.util.Key
    private java.lang.Long maxheight;

    /** Maximum height in pixels for resulting image.

   [maximum: 4096]
     */
    public java.lang.Long getMaxheight() {
      return maxheight;
    }

    /** Maximum height in pixels for resulting image. */
    public Image setMaxheight(java.lang.Long maxheight) {
      this.maxheight = maxheight;
      return this;
    }

    /**
     * Use the image associated with this secondary id if no image is associated with the primary
     * id.
     */
    @com.google.api.client.util.Key
    private java.lang.String fallbackid;

    /** Use the image associated with this secondary id if no image is associated with the primary id.
   [default: /freebase/no_image_png]
     */
    public java.lang.String getFallbackid() {
      return fallbackid;
    }

    /**
     * Use the image associated with this secondary id if no image is associated with the primary
     * id.
     */
    public Image setFallbackid(java.lang.String fallbackid) {
      if (!getSuppressPatternChecks()) {
        com.google.api.client.util.Preconditions.checkArgument(FALLBACKID_PATTERN.matcher(fallbackid).matches(),
            "Parameter fallbackid must conform to the pattern " +
            "/[^.]*$");
      }
      this.fallbackid = fallbackid;
      return this;
    }

    /**
     * A boolean specifying whether the resulting image should be padded up to the requested
     * dimensions.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean pad;

    /** A boolean specifying whether the resulting image should be padded up to the requested dimensions.
   [default: false]
     */
    public java.lang.Boolean getPad() {
      return pad;
    }

    /**
     * A boolean specifying whether the resulting image should be padded up to the requested
     * dimensions.
     */
    public Image setPad(java.lang.Boolean pad) {
      this.pad = pad;
      return this;
    }

    /**
     * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
     *
     * <p>
     * Boolean properties can have four possible values:
     * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
     * or {@link Boolean#FALSE}.
     * </p>
     *
     * <p>
     * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
     * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
     * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * </p>
     *
     * <p>
     * A boolean specifying whether the resulting image should be padded up to the requested dimensions.
     * </p>
     */
    public boolean isPad() {
      if (pad == null || pad == com.google.api.client.util.Data.NULL_BOOLEAN) {
        return false;
      }
      return pad;
    }

    /** Method used to scale or crop image. */
    @com.google.api.client.util.Key
    private java.lang.String mode;

    /** Method used to scale or crop image. [default: fit]
     */
    public java.lang.String getMode() {
      return mode;
    }

    /** Method used to scale or crop image. */
    public Image setMode(java.lang.String mode) {
      this.mode = mode;
      return this;
    }

    @Override
    public Image set(String parameterName, Object value) {
      return (Image) super.set(parameterName, value);
    }
  }

  /**
   * Performs MQL Queries.
   *
   * Create a request for the method "mqlread".
   *
   * This request holds the parameters needed by the the freebase server.  After setting any optional
   * parameters, call the {@link Mqlread#execute()} method to invoke the remote operation.
   *
   * @param query An envelope containing a single MQL query.
   * @return the request
   */
  public Mqlread mqlread(java.lang.String query) throws java.io.IOException {
    Mqlread result = new Mqlread(query);
    initialize(result);
    return result;
  }

  public class Mqlread extends FreebaseRequest<Void> {

    private static final String REST_PATH = "mqlread";

    private final java.util.regex.Pattern CALLBACK_PATTERN =
        java.util.regex.Pattern.compile("([A-Za-z0-9_$.]|\\[|\\])+");

    /**
     * Performs MQL Queries.
     *
     * Create a request for the method "mqlread".
     *
     * This request holds the parameters needed by the the freebase server.  After setting any
     * optional parameters, call the {@link Mqlread#execute()} method to invoke the remote operation.
     * <p> {@link
     * Mqlread#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
     * be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param query An envelope containing a single MQL query.
     * @since 1.13
     */
    protected Mqlread(java.lang.String query) {
      super(Freebase.this, "GET", REST_PATH, null, Void.class);
      this.query = com.google.api.client.util.Preconditions.checkNotNull(query, "Required parameter query must be specified.");
      initializeMediaDownload();
    }

    @Override
    public void executeMediaAndDownloadTo(java.io.OutputStream outputStream) throws java.io.IOException {
      super.executeMediaAndDownloadTo(outputStream);
    }

    @Override
    public java.io.InputStream executeMediaAsInputStream() throws java.io.IOException {
      return super.executeMediaAsInputStream();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeMedia() throws java.io.IOException {
      return super.executeMedia();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
      return super.executeUsingHead();
    }

    @Override
    public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
      return super.buildHttpRequestUsingHead();
    }

    @Override
    public Mqlread setAlt(java.lang.String alt) {
      return (Mqlread) super.setAlt(alt);
    }

    @Override
    public Mqlread setFields(java.lang.String fields) {
      return (Mqlread) super.setFields(fields);
    }

    @Override
    public Mqlread setKey(java.lang.String key) {
      return (Mqlread) super.setKey(key);
    }

    @Override
    public Mqlread setOauthToken(java.lang.String oauthToken) {
      return (Mqlread) super.setOauthToken(oauthToken);
    }

    @Override
    public Mqlread setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (Mqlread) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public Mqlread setQuotaUser(java.lang.String quotaUser) {
      return (Mqlread) super.setQuotaUser(quotaUser);
    }

    @Override
    public Mqlread setUserIp(java.lang.String userIp) {
      return (Mqlread) super.setUserIp(userIp);
    }

    /** An envelope containing a single MQL query. */
    @com.google.api.client.util.Key
    private java.lang.String query;

    /** An envelope containing a single MQL query.
     */
    public java.lang.String getQuery() {
      return query;
    }

    /** An envelope containing a single MQL query. */
    public Mqlread setQuery(java.lang.String query) {
      this.query = query;
      return this;
    }

    /** The language of the results - an id of a /type/lang object. */
    @com.google.api.client.util.Key
    private java.lang.String lang;

    /** The language of the results - an id of a /type/lang object. [default: /lang/en]
     */
    public java.lang.String getLang() {
      return lang;
    }

    /** The language of the results - an id of a /type/lang object. */
    public Mqlread setLang(java.lang.String lang) {
      this.lang = lang;
      return this;
    }

    /** Whether or not to escape entities. */
    @com.google.api.client.util.Key("html_escape")
    private java.lang.Boolean htmlEscape;

    /** Whether or not to escape entities. [default: true]
     */
    public java.lang.Boolean getHtmlEscape() {
      return htmlEscape;
    }

    /** Whether or not to escape entities. */
    public Mqlread setHtmlEscape(java.lang.Boolean htmlEscape) {
      this.htmlEscape = htmlEscape;
      return this;
    }

    /**
     * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
     *
     * <p>
     * Boolean properties can have four possible values:
     * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
     * or {@link Boolean#FALSE}.
     * </p>
     *
     * <p>
     * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
     * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
     * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * </p>
     *
     * <p>
     * Whether or not to escape entities.
     * </p>
     */
    public boolean isHtmlEscape() {
      if (htmlEscape == null || htmlEscape == com.google.api.client.util.Data.NULL_BOOLEAN) {
        return true;
      }
      return htmlEscape;
    }

    /** How many spaces to indent the json. */
    @com.google.api.client.util.Key
    private java.lang.Long indent;

    /** How many spaces to indent the json. [default: 0]

   [maximum: 10]
     */
    public java.lang.Long getIndent() {
      return indent;
    }

    /** How many spaces to indent the json. */
    public Mqlread setIndent(java.lang.Long indent) {
      this.indent = indent;
      return this;
    }

    /** How MQL responds to uniqueness failures. */
    @com.google.api.client.util.Key("uniqueness_failure")
    private java.lang.String uniquenessFailure;

    /** How MQL responds to uniqueness failures. [default: hard]
     */
    public java.lang.String getUniquenessFailure() {
      return uniquenessFailure;
    }

    /** How MQL responds to uniqueness failures. */
    public Mqlread setUniquenessFailure(java.lang.String uniquenessFailure) {
      this.uniquenessFailure = uniquenessFailure;
      return this;
    }

    /** The dateline that you get in a mqlwrite response to ensure consistent results. */
    @com.google.api.client.util.Key
    private java.lang.String dateline;

    /** The dateline that you get in a mqlwrite response to ensure consistent results.
     */
    public java.lang.String getDateline() {
      return dateline;
    }

    /** The dateline that you get in a mqlwrite response to ensure consistent results. */
    public Mqlread setDateline(java.lang.String dateline) {
      this.dateline = dateline;
      return this;
    }

    /** The mql cursor. */
    @com.google.api.client.util.Key
    private java.lang.String cursor;

    /** The mql cursor.
     */
    public java.lang.String getCursor() {
      return cursor;
    }

    /** The mql cursor. */
    public Mqlread setCursor(java.lang.String cursor) {
      this.cursor = cursor;
      return this;
    }

    /** JS method name for JSONP callbacks. */
    @com.google.api.client.util.Key
    private java.lang.String callback;

    /** JS method name for JSONP callbacks.
     */
    public java.lang.String getCallback() {
      return callback;
    }

    /** JS method name for JSONP callbacks. */
    public Mqlread setCallback(java.lang.String callback) {
      if (!getSuppressPatternChecks()) {
        com.google.api.client.util.Preconditions.checkArgument(CALLBACK_PATTERN.matcher(callback).matches(),
            "Parameter callback must conform to the pattern " +
            "([A-Za-z0-9_$.]|\\[|\\])+");
      }
      this.callback = callback;
      return this;
    }

    /** Show the costs or not. */
    @com.google.api.client.util.Key
    private java.lang.Boolean cost;

    /** Show the costs or not. [default: false]
     */
    public java.lang.Boolean getCost() {
      return cost;
    }

    /** Show the costs or not. */
    public Mqlread setCost(java.lang.Boolean cost) {
      this.cost = cost;
      return this;
    }

    /**
     * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
     *
     * <p>
     * Boolean properties can have four possible values:
     * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
     * or {@link Boolean#FALSE}.
     * </p>
     *
     * <p>
     * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
     * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
     * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
     * </p>
     *
     * <p>
     * Show the costs or not.
     * </p>
     */
    public boolean isCost() {
      if (cost == null || cost == com.google.api.client.util.Data.NULL_BOOLEAN) {
        return false;
      }
      return cost;
    }

    /** Run the query as it would've been run at the specified point in time. */
    @com.google.api.client.util.Key("as_of_time")
    private java.lang.String asOfTime;

    /** Run the query as it would've been run at the specified point in time.
     */
    public java.lang.String getAsOfTime() {
      return asOfTime;
    }

    /** Run the query as it would've been run at the specified point in time. */
    public Mqlread setAsOfTime(java.lang.String asOfTime) {
      this.asOfTime = asOfTime;
      return this;
    }

    @Override
    public Mqlread set(String parameterName, Object value) {
      return (Mqlread) super.set(parameterName, value);
    }
  }

  /**
   * Performs MQL Write Operations.
   *
   * Create a request for the method "mqlwrite".
   *
   * This request holds the parameters needed by the the freebase server.  After setting any optional
   * parameters, call the {@link Mqlwrite#execute()} method to invoke the remote operation.
   *
   * @param query An MQL query with write directives.
   * @return the request
   */
  public Mqlwrite mqlwrite(java.lang.String query) throws java.io.IOException {
    Mqlwrite result = new Mqlwrite(query);
    initialize(result);
    return result;
  }

  public class Mqlwrite extends FreebaseRequest<Void> {

    private static final String REST_PATH = "mqlwrite";

    private final java.util.regex.Pattern CALLBACK_PATTERN =
        java.util.regex.Pattern.compile("([A-Za-z0-9_$.]|\\[|\\])+");

    /**
     * Performs MQL Write Operations.
     *
     * Create a request for the method "mqlwrite".
     *
     * This request holds the parameters needed by the the freebase server.  After setting any
     * optional parameters, call the {@link Mqlwrite#execute()} method to invoke the remote operation.
     * <p> {@link
     * Mqlwrite#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
     * must be called to initialize this instance immediately after invoking the constructor. </p>
     *
     * @param query An MQL query with write directives.
     * @since 1.13
     */
    protected Mqlwrite(java.lang.String query) {
      super(Freebase.this, "GET", REST_PATH, null, Void.class);
      this.query = com.google.api.client.util.Preconditions.checkNotNull(query, "Required parameter query must be specified.");
      initializeMediaDownload();
    }

    @Override
    public void executeMediaAndDownloadTo(java.io.OutputStream outputStream) throws java.io.IOException {
      super.executeMediaAndDownloadTo(outputStream);
    }

    @Override
    public java.io.InputStream executeMediaAsInputStream() throws java.io.IOException {
      return super.executeMediaAsInputStream();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeMedia() throws java.io.IOException {
      return super.executeMedia();
    }

    @Override
    public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
      return super.executeUsingHead();
    }

    @Override
    public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
      return super.buildHttpRequestUsingHead();
    }

    @Override
    public Mqlwrite setAlt(java.lang.String alt) {
      return (Mqlwrite) super.setAlt(alt);
    }

    @Override
    public Mqlwrite setFields(java.lang.String fields) {
      return (Mqlwrite) super.setFields(fields);
    }

    @Override
    public Mqlwrite setKey(java.lang.String key) {
      return (Mqlwrite) super.setKey(key);
    }

    @Override
    public Mqlwrite setOauthToken(java.lang.String oauthToken) {
      return (Mqlwrite) super.setOauthToken(oauthToken);
    }

    @Override
    public Mqlwrite setPrettyPrint(java.lang.Boolean prettyPrint) {
      return (Mqlwrite) super.setPrettyPrint(prettyPrint);
    }

    @Override
    public Mqlwrite setQuotaUser(java.lang.String quotaUser) {
      return (Mqlwrite) super.setQuotaUser(quotaUser);
    }

    @Override
    public Mqlwrite setUserIp(java.lang.String userIp) {
      return (Mqlwrite) super.setUserIp(userIp);
    }

    /** An MQL query with write directives. */
    @com.google.api.client.util.Key
    private java.lang.String query;

    /** An MQL query with write directives.
     */
    public java.lang.String getQuery() {
      return query;
    }

    /** An MQL query with write directives. */
    public Mqlwrite setQuery(java.lang.String query) {
      this.query = query;
      return this;
    }

    /** JS method name for JSONP callbacks. */
    @com.google.api.client.util.Key
    private java.lang.String callback;

    /** JS method name for JSONP callbacks.
     */
    public java.lang.String getCallback() {
      return callback;
    }

    /** JS method name for JSONP callbacks. */
    public Mqlwrite setCallback(java.lang.String callback) {
      if (!getSuppressPatternChecks()) {
        com.google.api.client.util.Preconditions.checkArgument(CALLBACK_PATTERN.matcher(callback).matches(),
            "Parameter callback must conform to the pattern " +
            "([A-Za-z0-9_$.]|\\[|\\])+");
      }
      this.callback = callback;
      return this;
    }

    /** The dateline that you get in a mqlwrite response to ensure consistent results. */
    @com.google.api.client.util.Key
    private java.lang.String dateline;

    /** The dateline that you get in a mqlwrite response to ensure consistent results.
     */
    public java.lang.String getDateline() {
      return dateline;
    }

    /** The dateline that you get in a mqlwrite response to ensure consistent results. */
    public Mqlwrite setDateline(java.lang.String dateline) {
      this.dateline = dateline;
      return this;
    }

    /** How many spaces to indent the json. */
    @com.google.api.client.util.Key
    private java.lang.Long indent;

    /** How many spaces to indent the json. [default: 0]

   [maximum: 10]
     */
    public java.lang.Long getIndent() {
      return indent;
    }

    /** How many spaces to indent the json. */
    public Mqlwrite setIndent(java.lang.Long indent) {
      this.indent = indent;
      return this;
    }

    /** Use the same permission node of the object with the specified id. */
    @com.google.api.client.util.Key("use_permission_of")
    private java.lang.String usePermissionOf;

    /** Use the same permission node of the object with the specified id.
     */
    public java.lang.String getUsePermissionOf() {
      return usePermissionOf;
    }

    /** Use the same permission node of the object with the specified id. */
    public Mqlwrite setUsePermissionOf(java.lang.String usePermissionOf) {
      this.usePermissionOf = usePermissionOf;
      return this;
    }

    @Override
    public Mqlwrite set(String parameterName, Object value) {
      return (Mqlwrite) super.set(parameterName, value);
    }
  }

  /**
   * Builder for {@link Freebase}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport, which should normally be:
     *        <ul>
     *        <li>Google App Engine:
     *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
     *        <li>Android: {@code newCompatibleTransport} from
     *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
     *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
     *        </li>
     *        </ul>
     * @param jsonFactory JSON factory, which may be:
     *        <ul>
     *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
     *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
     *        <li>Android Honeycomb or higher:
     *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
     *        </ul>
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
        com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Freebase}. */
    @Override
    public Freebase build() {
      return new Freebase(this);
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    @Override
    public Builder setSuppressRequiredParameterChecks(boolean suppressRequiredParameterChecks) {
      return (Builder) super.setSuppressRequiredParameterChecks(suppressRequiredParameterChecks);
    }

    @Override
    public Builder setSuppressAllChecks(boolean suppressAllChecks) {
      return (Builder) super.setSuppressAllChecks(suppressAllChecks);
    }

    /**
     * Set the {@link FreebaseRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setFreebaseRequestInitializer(
        FreebaseRequestInitializer freebaseRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(freebaseRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        com.google.api.client.googleapis.services.GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
